Firestarter firewall continuously crashes no matter which desktop or screen it's on.

Bug #120445 reported by Bill Hand on 2007-06-14
292
Affects Status Importance Assigned to Milestone
firestarter
Expired
Critical
firestarter (Debian)
Fix Released
Unknown
firestarter (Fedora)
New
Undecided
Unassigned
firestarter (Ubuntu)
Medium
Luca Falavigna
Gutsy
Medium
Unassigned

Bug Description

Binary package hint: firestarter

Firestarter firewall continuously crashes. I have tried to isolate if there is any specific thing that causes it and there doesn't seem to be any one thing. It just quits. This started at last nights updates; that's when I noticed it. (Before the Nautilus updates, though). I am running Gutsy... I have tried to run it on both desktops, I have an Nvidia GeForce 6800 and run two separate monitors/desktops and it doesn't matter which it's on. I am presently on Firestarter version: 1.0.3-2ubuntu2 (gutsy) and there doesn't seem to be a way to force it back to a previous version.

TEST CASE:
1. Install affected firestarter version from gutsy (universe) repository (1.0.3-6ubuntu1).
2. Launch the gui portion using the menu item System>Administration>Firestarter
3. Proceed through mandatory initial configuration if launching the gui for first time.
4. In the firestarter main view select the "Status" tab and click "Active connections" text to expand the connections list.
5. Create some network activity by browsing the internet normally, so that "Active connections" list starts to increase/decrease.
6. Firestarter crashes after some period. This period usually varies though.

Same behavior can be reproduced in the "Policy" tab, by adding/removing new inbound service rules.

Related branches

Artūras Lukošius (belaidis) wrote :

The same happened to me. I am running Gutsy with the latest updates.

Artūras Lukošius (belaidis) wrote :

~$ sudo firestarter
Firewall started
Adding Firestarter startup hook to /etc/dhclient-exit-hooks
Firewall started

***MEMORY-ERROR***: firestarter[3290]: GSlice: assertion failed: sinfo->n_allocated > 0
Aborted

Bill Hand (fxwgbill-gmail) wrote :

I have also confirmed now, that it occurs with either the Gnome or KDE desktop. That doesn't seem to make a difference. What does seem to help sometimes, though, is to stay on the same desktop that it it is on.

Lionel Le Folgoc (mrpouit) wrote :

Hi,

Thanks for your bug report.
Could you provide a backtrace when the program crashes? (see https://wiki.ubuntu.com/DebuggingProgramCrash)

Changed in firestarter:
assignee: nobody → mrpouit
status: Unconfirmed → Needs Info
Artūras Lukošius (belaidis) wrote :

I am working on obtaining more information but I wanted to pass this
discovery along: as long as you don't click on the 'Active connections'
drop down field, Firestarter will not crash. I keep an eye on who and
what I am connecting to and who to me, so I typically click on the drop
down and glance at it periodically. When I don't open it, it stays up.

Bill

Bill Hand wrote:
> <pre wrap>Public bug reported:
>
> Binary package hint: firestarter
>
> Firestarter firewall continuously crashes. I have tried to isolate if
> there is any specific thing that causes it and there doesn't seem to be
> any one thing. It just quits. This started at last nights updates;
> that's when I noticed it. (Before the Nautilus updates, though). I am
> running Gutsy... I have tried to run it on both desktops, I have an
> Nvidia GeForce 6800 and run two separate monitors/desktops and it
> doesn't matter which it's on. I am presently on Firestarter version:
> 1.0.3-2ubuntu2 (gutsy) and there doesn't seem to be a way to force it
> back to a previous version.
>
> ** Affects: firestarter (Ubuntu)
> Importance: Undecided
> Status: Unconfirmed
>
> </pre></body>
> </html>
> </html>

Added Bug #130913 as duplicate.
Also attaching crash report from /var/crash

Confirming Bill Hand's tip. As long as I don't open Active Connections, Firestarter doesn't exit with memory error.

Changing Importance to Low since there's an existing workaround to prevent Firestarter from exiting.

Changed in firestarter:
importance: Undecided → Low
Yves-Antoine (yae) wrote :

The crash is still there with version 1.0.3-6ubuntu1 as of 30th of September 2007.
It looks like one has to drop down active connections AND refresh event list for the bug to occur.

In this version, the message log in a terminal window is :
---------------------------------------------------
Firewall started
Finished reading events list

***MEMORY-ERROR***: firestarter[6356]: GSlice: assertion failed: sinfo->n_allocated > 0
Abandon
------------------------------------------------------
The line number between brackets can vary though : I also got [6563]

Why is the bug flagged as incomplete ?

This is still an issue with Gutsy Beta.
I believe we have all the information the devs need. Changing Status to Triaged.

Changed in firestarter:
status: Incomplete → Triaged

Maybe because it has never been fixed, I still have this exact problem....

Thanx,

Bill

Yves-Antoine wrote:
> The crash is still there with version 1.0.3-6ubuntu1 as of 30th of September 2007.
> It looks like one has to drop down active connections AND refresh event list for the bug to occur.
>
> In this version, the message log in a terminal window is :
> ---------------------------------------------------
> Firewall started
> Finished reading events list
>
> ***MEMORY-ERROR***: firestarter[6356]: GSlice: assertion failed: sinfo->n_allocated > 0
> Abandon
> ------------------------------------------------------
> The line number between brackets can vary though : I also got [6563]
>
> Why is the bug flagged as incomplete ?
>
>

Stéphane Marguet (stemp) wrote :

I just sent it upstream a few hours ago, be patient ;)
BTW I don't think the importance should be low

Changed in firestarter:
status: Unknown → New

I too have a problem with firestarter on Gutsy. If I install it and use it its fine, I believe it has crashed a few times. BUT the main issue with me is (and this is one hello of an issue) is that while firestarter is installed, it seems to conflict with my wireless card (a ralink fsd7050 using the rt73 kernel module) so when booting up I get some message line wlan0 not found then a few other messages and finally the system boots up but wireless cannot be brought up, mpd isn't running and many other 'issues'.

I have included a crash report and will check back later, so let me know if you would like any other things. Note that I don't have it installed now obviously, as it crashes my ubuntu!

Vitor Lamas Gatti (vitorgatti) wrote :

Same bug here.
Using Ubuntu 7.10 full-updated and firestarter simply crashes itself, with memory error (segmentation fault).
I didn't check that if I don't open Active Connections it doesn't crash, but I think this is true.

Well, beta-test have already passed and this bug continues...
Maybe checking the code on the event when clicking the button "Active Connections" and comparing with an older version (for Ubuntu 7.04, ie) to see if there isn't some mistakes?

Strange bug...

acidwhisper (venusdm-rkd) wrote :

Hi all
the same here, Kubuntu 7.10

$sudo firestarter

Firewall started

***MEMORY-ERROR***: firestarter[7102]: GSlice: assertion failed: sinfo->n_allocated > 0
Aborted (core dumped)

Shivinder Singh (shivinder) wrote :

Same here guys :(
Ubuntu - Gutsy Gibbon, with all latest updates.

bruteforce@vinci:~$ sudo firestarter
[sudo] password for bruteforce:
Firewall started

***MEMORY-ERROR***: firestarter[9685]: GSlice: assertion failed: sinfo->n_allocated > 0
Aborted (core dumped)
bruteforce@vinci:~$

I have a problem similar to chronographer. Interface wlan0 disappears when I install firestarter and reboot. I am using the RT61 driver form serialmonkey. I am using Kubuntu gutsy AMD64.

Hey Michael

Thats the source of my drivers too, serialmonkey http://rt2x00.serialmonkey.com/rt73-cvs-daily.tar.gz It works flawlessly, just conflicts with firestarter on startup...

If I install firestarter and use it, its fine, no seg fault, BUT if I try to restart, the system freezes. If I uninstall firestarter before I restart, everything is fine!

See my post above for a crash report.

Nikola M (nikolam) wrote :

Firestarter GUI dies if you touch active-connections list.

Also, active connections list tend to display
connections that does not exists anymore, even after
turning up/down connection itself..
(in my case azureus/java connections)

Kostya (kostya1) wrote :

Yes, I've also noticed ghost connections in the Active Connections list. But for me it was happening even before upgrade to Gutsy, so I believe it is a bug but it is most likely unrelated to the crashes of the Firestarter GUI bug.

Matti Lindell (mlind) wrote :

Does this happen if you start firestarter GUI using G_SLICE=always-malloc ?

G_SLICE=always-malloc sudo firestarter

Stéphane Marguet (stemp) wrote :

@mlind : I launch it half an hour ago with your parameter and it's still running ! Great !

fralk (fmonte) wrote :

@mlind: I tried your command but it crashed with segmentation fault after a few minutes (tested with "Active connections" expanded)

RoLex (hundrambit) wrote :

Confirming Vitor Lamas Gatti's comment; it works great on 7.04, but crashes on 7.10.

In my case it crashes even with unexpanded active connections, It's enough with editing/adding/deleting rules for inbound traffic policy 2-3 times.

fralk (fmonte) wrote :

Apparently, when opening any listbox, be it "Active connections", "Events" or "Policy", it crashes after a while.
I kept it running the GUI for hours without opening any of them, and it didn't crash (it's still running :) ).

Kostya (kostya1) wrote :

Using G_SLICE=always-malloc seems to prevent the crashes.

Matti Lindell (mlind) wrote :

firestarter is leaking somewhere and gtk+ doesn't like it

***MEMORY-ERROR***: firestarter[31702]: GSlice: assertion failed: sinfo->n_allocated > 0

Program received signal SIGABRT, Aborted.
[Switching to Thread -1247913072 (LWP 392)]
0xffffe410 in __kernel_vsyscall ()

Thread 53 (Thread -1247913072 (LWP 392)):
#0 0xffffe410 in __kernel_vsyscall ()
#1 0xb71cf875 in raise () from /lib/tls/i686/cmov/libc.so.6
#2 0xb71d1201 in abort () from /lib/tls/i686/cmov/libc.so.6
#3 0xb7350e42 in mem_error (format=0xb738d4aa "assertion failed: %s") at /build/buildd/glib2.0-2.14.1/glib/gslice.c:1197
#4 0xb7350f98 in slab_allocator_free_chunk (chunk_size=<value optimized out>, mem=0x8441fe8) at /build/buildd/glib2.0-2.14.1/glib/gslice.c:1079
#5 0xb73513b8 in private_thread_memory_cleanup (data=0x847c658) at /build/buildd/glib2.0-2.14.1/glib/gslice.c:720
#6 0xb72f3ba0 in __nptl_deallocate_tsd () from /lib/tls/i686/cmov/libpthread.so.0
#7 0xb72f4479 in start_thread () from /lib/tls/i686/cmov/libpthread.so.0
#8 0xb72786de in clone () from /lib/tls/i686/cmov/libc.so.6

Matti Lindell (mlind) wrote :
Saivann Carignan (oxmosys) wrote :
Download full text (6.1 KiB)

I tested the "G_SLICE=always-malloc sudo firestarter" command and I got it to work without crashing, I tested the windows 20 minutes and it didn't crash in this time.

Here's what I got in the terminal when I started firestarter for the first time ( the errors about missing file is just because there's no existing configuration files yet )

zxz@zxz-desktop:~$ sudo firestarter
[sudo] password for zxz:
Error reading file /etc/firestarter/inbound/allow-from: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/inbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/inbound/forward: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/deny-to: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/deny-from: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/deny-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-to: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-from: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Error reading file /etc/firestarter/outbound/allow-service: Aucun fichier ou répertoire de ce type
Warning: External interface previously configured not found
Warning: Internal interface previously configured not found
Script du pare-feu enregistré dans /etc/firestarter/firewall
External network device eth0 is not ready. Aborting..
Internal network device tap1 is not ready. Aborting..
Firewall started
*** glibc detected *** firestarter: corrupted double-linked list: 0x084ea5d0 ***
======= Backtrace: =========
/lib/tls/i686/cmov/libc.so.6[0xb725a3f9]
/lib/tls/i686/cmov/libc.so.6[0xb725c1bd]
/lib/tls/i686/cmov/libc.so.6(__libc_malloc+0x90)[0xb725dfc0]
/usr/lib/libcairo.so.2[0xb766c025]
/usr/lib/libcairo.so.2[0xb766c255]
/usr/lib/libcairo.so.2[0xb76611a9]
/usr/lib/libcairo.so.2[0xb7661dc3]
/usr/lib/libcairo.so.2[0xb766b345]
/usr/lib/libcairo.so.2[0xb766894b]
/usr/lib/libcairo.so.2[0xb765b5b9]
/usr/lib/libcairo.so.2(cairo_stroke_preserve+0x2c)[0xb7653fac]
/usr/lib/libcairo.so.2(cairo_stroke+0x12)[0xb7653fd2]
/usr/lib/gtk-2.0/2.10.0/engines/libubuntulooks.so[0xb6d21497]
/usr/lib/gtk-2.0/2.10.0/engines/libubuntulooks.so(ubuntulooks_draw_frame+0x2b0)[0xb6d22460]
/usr/lib/gtk-2.0/2.10.0/engines/libubuntulooks.so[0xb6d188df]
/usr/lib/libgtk-x11-2.0.so.0(gtk_paint_box_gap+0xcd)[0xb7ae1a2d]
/usr/lib/libgtk-x11-2.0.so.0[0xb7a8a4df]
/usr/lib/libgtk-x11-2.0.so.0(_gtk_marshal_BOOLEAN__BOXED+0x5e)[0xb7a6c1de]
/usr/lib/libgobject-2.0....

Read more...

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

I started firestarter with G_SLICE=always-malloc sudo firestarter
command and its working fine for now. No crashes.
But I get the line below after some time.
(firestarter:6102): GLib-CRITICAL **: g_str_has_suffix: assertion `str
!= NULL' failed

Its still running though.
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org

iD8DBQFHL96SaMl3WyCZM24RAqKbAJ9/absO2f8GfLwv4Qh8XpsK9SH9cACgg2bg
ZqdzYHj0oSga7gW35xNoad4=
=7R44
-----END PGP SIGNATURE-----

Bryan (brywilharris) wrote :

G_SLICE=always-malloc gksu /usr/sbin/firestarter

This workaround fixes the crashing for me.

Bryan (brywilharris) wrote :

G_SLICE=always-malloc gksu /usr/sbin/firestarter

fixes the problem for me.

2.6.22-14-386 #1 Sun Oct 14 22:36:54 GMT 2007 i686 GNU/Linux
Firestarter 1.0.3

Diego Foglino (biker84) wrote :

This is my report

Bill Hand (fxwgbill-gmail) wrote :

Doesn't for me...

Bill

myric wrote:
> G_SLICE=always-malloc gksu /usr/sbin/firestarter
>
> This workaround fixes the crashing for me.
>
>

Andrey Vihrov (andrey.vihrov) wrote :

I've encountered the same issue here with firestarter 1.0.3-5ubuntu1 on Ubuntu 7.10 with kernel 2.6.22.14.21 x86-64. G_SLICE=always-malloc fixes the problem.

fralk (fmonte) wrote :

for people whom the workaround G_SLICE=always-malloc gksu /usr/sbin/firestarter doesn't work:
probably it is because G_SLICE is not passed to the su environment, for some reason.

Try and change in /etc/sudoers (with command "sudo visudo") the line "Defaults" like this:
Defaults !lecture,tty_tickets,!fqdn,env_keep+="DISPLAY G_SLICE HOME"

it should work...

Matti Lindell (mlind) wrote :

I'm raising importance a bit as this is a crasher bug. G_SLICE=always-malloc is just a workaround, not a fix.

Changed in firestarter:
importance: Low → Medium
Richard de Rivaz (richard-mdr) wrote :

Firestarter crashes are interfering with backups which is rather concerning. The following error when running Firestarter using ssh X11 may be assistance:

(firestarter:17702): Gdk-CRITICAL **: gdk_x11_image_get_ximage: assertion `GDK_IS_IMAGE (image)' failed
Segmentation fault (core dumped)

Matti Lindell (mlind) wrote :

I reckon the problem is GtkListStore usage which is used as a data model in "Active connections" view. My gtk+ programming knowledge is zero, so if anyone more savvy with gtk+ could take this task, it would be great.

The issue seems to be in statusview.c, and in functions connectionview_append_connection () and free_connection_entry (). gtk_tree_iter_free (entry->ref); is tying to free unallocated block of memory which is related to new GSlice memory allocator behaviour.

I'm attaching a patch as a reference. Even if it fixes this issue, it may introduce nice leak too.

Richard de Rivaz (richard-mdr) wrote :
Download full text (18.4 KiB)

Here is Firestarter crash info:

Firewall started
*** glibc detected *** firestarter: corrupted double-linked list: 0x084935e0 ***
======= Backtrace: =========
/lib/tls/i686/cmov/libc.so.6[0xb71c8074]
/lib/tls/i686/cmov/libc.so.6[0xb71c8863]
/lib/tls/i686/cmov/libc.so.6(realloc+0x106)[0xb71caa66]
/usr/lib/libcairo.so.2[0xb75ce332]
/usr/lib/libcairo.so.2[0xb75cd549]
/usr/lib/libcairo.so.2[0xb75cb90d]
/usr/lib/libcairo.so.2[0xb75cce54]
/usr/lib/libcairo.so.2[0xb75d6345]
/usr/lib/libcairo.so.2[0xb75d394b]
/usr/lib/libcairo.so.2[0xb75c65b9]
/usr/lib/libcairo.so.2(cairo_stroke_preserve+0x2c)[0xb75befac]
/usr/lib/libcairo.so.2(cairo_stroke+0x12)[0xb75befd2]
/usr/lib/gtk-2.0/2.10.0/engines/libubuntulooks.so(ubuntulooks_draw_tab+0x27c)[0xb6cbb9dc]
/usr/lib/gtk-2.0/2.10.0/engines/libubuntulooks.so[0xb6cb25c3]
/usr/lib/libgtk-x11-2.0.so.0(gtk_paint_extension+0xbb)[0xb7a4c91b]
/usr/lib/libgtk-x11-2.0.so.0[0xb79f4fd1]
/usr/lib/libgtk-x11-2.0.so.0[0xb79f554f]
/usr/lib/libgtk-x11-2.0.so.0(_gtk_marshal_BOOLEAN__BOXED+0x5e)[0xb79d71de]
/usr/lib/libgobject-2.0.so.0[0xb738df89]
/usr/lib/libgobject-2.0.so.0(g_closure_invoke+0x20c)[0xb738f85c]
/usr/lib/libgobject-2.0.so.0[0xb73a0973]
/usr/lib/libgobject-2.0.so.0(g_signal_emit_valist+0x68f)[0xb73a160f]
/usr/lib/libgobject-2.0.so.0(g_signal_emit+0x29)[0xb73a1a09]
/usr/lib/libgtk-x11-2.0.so.0[0xb7af5498]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_propagate_expose+0x139)[0xb7939099]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939131]
/usr/lib/libbonoboui-2.so.0[0xb7e2bb4c]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_forall+0x6b)[0xb7939b2b]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939bf4]
/usr/lib/libgtk-x11-2.0.so.0(_gtk_marshal_BOOLEAN__BOXED+0x5e)[0xb79d71de]
/usr/lib/libgobject-2.0.so.0[0xb738df89]
/usr/lib/libgobject-2.0.so.0(g_closure_invoke+0x20c)[0xb738f85c]
/usr/lib/libgobject-2.0.so.0[0xb73a0973]
/usr/lib/libgobject-2.0.so.0(g_signal_emit_valist+0x68f)[0xb73a160f]
/usr/lib/libgobject-2.0.so.0(g_signal_emit+0x29)[0xb73a1a09]
/usr/lib/libgtk-x11-2.0.so.0[0xb7af5498]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_propagate_expose+0x139)[0xb7939099]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939131]
/usr/lib/libgtk-x11-2.0.so.0[0xb78f8280]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_forall+0x6b)[0xb7939b2b]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939bf4]
/usr/lib/libgtk-x11-2.0.so.0(_gtk_marshal_BOOLEAN__BOXED+0x5e)[0xb79d71de]
/usr/lib/libgobject-2.0.so.0[0xb738df89]
/usr/lib/libgobject-2.0.so.0(g_closure_invoke+0x20c)[0xb738f85c]
/usr/lib/libgobject-2.0.so.0[0xb73a0973]
/usr/lib/libgobject-2.0.so.0(g_signal_emit_valist+0x68f)[0xb73a160f]
/usr/lib/libgobject-2.0.so.0(g_signal_emit+0x29)[0xb73a1a09]
/usr/lib/libgtk-x11-2.0.so.0[0xb7af5498]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_propagate_expose+0x139)[0xb7939099]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939131]
/usr/lib/libgtk-x11-2.0.so.0[0xb78f43df]
/usr/lib/libgtk-x11-2.0.so.0(gtk_container_forall+0x6b)[0xb7939b2b]
/usr/lib/libgtk-x11-2.0.so.0[0xb7939bf4]
/usr/lib/libgtk-x11-2.0.so.0[0xb7b0cad1]
/usr/lib/libgtk-x11-2.0.so.0(_gtk_marshal_BOOLEAN__BOXED+0x5e)[0xb79d71de]
/usr/lib/libgobject-2.0.so.0[0xb738df89]
/usr/lib/libgobject-2.0.so.0(g_closure_invoke+0x122)[0xb738f772]
/usr/lib/libgobject-2.0.so.0[...

Diego Foglino (biker84) wrote :

I have gutsy. I have downgrade firestarter package at version 1.0.3-2ubuntu1 (feisty repository), but the problem is always present.

TWO (two) wrote :

I'm having the same issue. Only just noticed today. I have Gutsy Gibbon and using Firestarter version 1.0.3-6ubuntu1.

Started the program via the Terminal and it showed up the following error after a while:

:~$ sudo firestarter
Firewall started

***MEMORY-ERROR***: firestarter[28436]: GSlice: assertion failed: sinfo->n_allocated > 0
Aborted

Nizar Kerkeni (nizarus) wrote :

in gutsy firestarter crashes after few minutes with message (in french)
Erreur de segmentation (core dumped)
translating
Segmentation fault (core dumped)

RobNeild (b-bigbob) wrote :

I had a look at the patch provided above (thanks mlind). It largely worked for me, but I slightly changed to make simpler and to fix another problem in preferences.c.

Testing with G_SLICE=debug-blocks. It seems that mem allocated with g_new needs to be freed with g_free, and gtk_tree_iter_copy needs a corresponding gtk_tree_iter_free. They don't like being mixed.

It doesn't look like there is much activity upstream.

Changed in firestarter:
assignee: mrpouit → nobody
Jallto (ltg-power) wrote :
Download full text (4.0 KiB)

*** glibc detected *** firestarter: munmap_chunk(): invalid pointer: 0x084507f0 ***
======= Backtrace: =========
/lib/tls/i686/cmov/libc.so.6(cfree+0x1bb)[0xb722892b]
/usr/lib/libglib-2.0.so.0(g_free+0x31)[0xb7353961]
/usr/lib/libglib-2.0.so.0(g_hash_table_replace+0xb9)[0xb733fcd9]
firestarter[0x8061a37]
/usr/lib/libglib-2.0.so.0[0xb734c8d6]
/usr/lib/libglib-2.0.so.0(g_main_context_dispatch+0x17c)[0xb734c11c]
/usr/lib/libglib-2.0.so.0[0xb734f55f]
/usr/lib/libglib-2.0.so.0(g_main_loop_run+0x1a9)[0xb734f909]
/usr/lib/libgtk-x11-2.0.so.0(gtk_main+0xb4)[0xb7a2f9e4]
firestarter[0x804fff5]
/lib/tls/i686/cmov/libc.so.6(__libc_start_main+0xe0)[0xb71d1050]
firestarter[0x804f1e1]
======= Memory map: ========
08048000-080b7000 r-xp 00000000 08:01 4965780 /usr/sbin/firestarter
080b7000-080b9000 rw-p 0006e000 08:01 4965780 /usr/sbin/firestarter
080b9000-084cc000 rw-p 080b9000 00:00 0 [heap]
b592d000-b5937000 r-xp 00000000 08:01 8355907 /lib/libgcc_s.so.1
b5937000-b5938000 rw-p 0000a000 08:01 8355907 /lib/libgcc_s.so.1
b5948000-b59a8000 rw-s 00000000 00:09 46366746 /SYSV00000000 (deleted)
b59a8000-b5a2c000 r--p 00000000 08:01 5197008 /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans-Bold.ttf
b5a2c000-b5a2d000 ---p b5a2c000 00:00 0
b5a2d000-b622d000 rw-p b5a2d000 00:00 0
b622d000-b6234000 r-xp 00000000 08:01 4966167 /usr/lib/libfam.so.0.0.0
b6234000-b6235000 rw-p 00006000 08:01 4966167 /usr/lib/libfam.so.0.0.0
b6235000-b623b000 r-xp 00000000 08:01 8355866 /lib/libacl.so.1.1.0
b623b000-b623c000 rw-p 00005000 08:01 8355866 /lib/libacl.so.1.1.0
b623c000-b623f000 r-xp 00000000 08:01 8355872 /lib/libattr.so.1.1.0
b623f000-b6240000 rw-p 00002000 08:01 8355872 /lib/libattr.so.1.1.0
b6250000-b625c000 r-xp 00000000 08:01 5029916 /usr/lib/gnome-vfs-2.0/modules/libfile.so
b625c000-b625d000 rw-p 0000b000 08:01 5029916 /usr/lib/gnome-vfs-2.0/modules/libfile.so
b625d000-b625f000 r-xp 00000000 08:01 5096764 /usr/lib/pango/1.6.0/modules/pango-basic-fc.so
b625f000-b6260000 rw-p 00001000 08:01 5096764 /usr/lib/pango/1.6.0/modules/pango-basic-fc.so
b6260000-b62eb000 r--p 00000000 08:01 5197009 /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf
b62eb000-b62f1000 r--s 00000000 08:01 1196117 /var/cache/fontconfig/945677eb7aeaf62f1d50efc3fb3ec7d8-x86.cache-2
b62f1000-b62f4000 r--s 00000000 08:01 1198650 /var/cache/fontconfig/e383d7ea5fbe662a33d9b44caf393297-x86.cache-2
b62f4000-b62f8000 r--s 00000000 08:01 1198649 /var/cache/fontconfig/921a30a17f0be15c70ac14043cb7a739-x86.cache-2
b62f8000-b62f9000 r--s 00000000 08:01 1198648 /var/cache/fontconfig/c69f04ab05004e31a6d5e715764f16d8-x86.cache-2
b62f9000-b62fa000 r--s 00000000 08:01 1198647 /var/cache/fontconfig/4c73fe0c47614734b17d736dbde7580a-x86.cache-2
b62fa000-b62fd000 r--s 00000000 08:01 1198646 /var/cache/fontconfig/a755afe4a08bf5b97852ceb7400b47bc-x86.cache-2
b62fd000-b62fe000 r--s 00000000 08:01 1198645 /var/cache/fontconfig/75a2cd575a62c63e802c11411fb87c37-x86.cache-2
b62fe000-b6304000 r--s 00000000 08:01 1199403 /var/cache/fontconfig/6d41288fd70b0be22e8c3a91e032eec0-x86.cache-2
b6304000-b6306000 r--s 00000000 08:01 1198643 /var/cache/fontconfig/de156ccd2eddbdc19d37a45b8b2aac9c-x86.cache-2
b6306000-b630e000 r--s 00000000 08:0...

Read more...

Matti Lindell (mlind) wrote :

Thanks RobNeild! I'm going to test this out and upload patched package to my ppa for people to test. If it works okay, let's push it in Hardy.

cement_head (andor-udel) wrote :

how does one apply this patch?

RobNeild (b-bigbob) wrote :

You can apply the patch, build and install firestarter doing something like

sudo apt-get build-dep firestarter
sudo apt-get install fakeroot
apt-get source firestarter
cd firestarter-1.0.3/src/
wget http://launchpadlibrarian.net/11480727/foo2.patch
patch < foo2.patch
cd ..
dpkg-buildpackage -rfakeroot
cd ..
sudo dpkg -i firestarter_1.0.3-6ubuntu1_i386.deb

cement_head (andor-udel) wrote :

patch works.

anyway to build the new patched firestarter such that the deb have a different name/number so that the UPDATE MANAGER isn't always trying to upgrade it?

Thanks
CH

Matti Lindell (mlind) wrote :

Patched package for Hardy testers is available in:
deb http://ppa.launchpad.net/mlind/ubuntu hardy main
deb-src http://ppa.launchpad.net/mlind/ubuntu hardy main

Patch fixes this issue for me too. Great work RobNeild! This would be an excellent backport candidate too.

cement_head (andor-udel) wrote :

mlind,

how do I build a deb and get a name change? i.e. from "firestarter_1.0.3-6ubuntu1_i386.deb" to "firestarter_1.0.3-6ubuntu1.1_i386.deb"?

thanks,
CH

Matti Lindell (mlind) wrote :

Here's a debdiff for hardy.

@cement_head
install package called devscripts and check 'man dch'. "dch -i" is probably what you're looking for.

cement_head (andor-udel) wrote :

wicked!

thanks...i've just learned how to patch & compile & version change.

sweet

L8R

Changed in firestarter:
assignee: nobody → kitterman
status: Triaged → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package firestarter - 1.0.3-6ubuntu2

---------------
firestarter (1.0.3-6ubuntu2) hardy; urgency=low

  * debian/patches/18_fix_memleak.dpatch:
    - Free allocated memory properly, patch by RobNeild (LP: #120445).

 -- Matti Lindell <email address hidden> Thu, 31 Jan 2008 20:44:24 +0200

Changed in firestarter:
status: In Progress → Fix Released
Scott Kitterman (kitterman) wrote :

Matti,

The build failed to build on HPPA. Please have a look at why so it can be fixed.

Matti Lindell (mlind) wrote :

Hi Scott,

According to http://launchpadlibrarian.net/11692981/buildlog_ubuntu-hardy-hppa.firestarter_1.0.3-6ubuntu2_FAILEDTOBUILD.txt.gz hppa doesn't have necessary gnome depends available as both recent libbonoboui and libgnomeui FTBFS on hppa:
http://launchpadlibrarian.net/11612760/buildlog_ubuntu-hardy-hppa.libgnomeui_2.21.90-0ubuntu1_FAILEDTOBUILD.txt.gz
http://launchpadlibrarian.net/11610953/buildlog_ubuntu-hardy-hppa.libbonoboui_2.21.90-1_FAILEDTOBUILD.txt.gz

From the firestarter build log:
The following packages have unmet dependencies:
  libgnomeui-dev: Depends: libbonoboui2-dev (>= 2.13.1) but it is not going to be installed
                  Depends: libgnomeui-0 (= 2.21.5-0ubuntu1) but it is not going to be installed
E: Broken packages

> The following packages have unmet dependencies:
> libgnomeui-dev: Depends: libbonoboui2-dev (>= 2.13.1) but it is not going
> to be installed Depends: libgnomeui-0 (= 2.21.5-0ubuntu1) but it is not
> going to be installed E: Broken packages

So the standard procedure in this case is to look into why that's true and see
if anything needs to be done to fix it. For hppa, often these things will
get fixed themselves and all you need to do is check periodically and see if
the packages have been built/fixed and if so we can ask an archive admin to
retry the build on hppa.

Matti Lindell (mlind) wrote :

Would this make sense as a SRU/backport candidate for Gutsy? The duplicate count is quite high and I bet more will appear from Gutsy users.

Scott Kitterman (kitterman) wrote :

Nominating for SRU due to high number of dupes and impact on the package. This appears to be a regression from Feisty.

Changed in firestarter:
importance: Undecided → Medium
Scott Kitterman (kitterman) wrote :

mlind:

If you would prepare a debdiff from the Gutsy version for the SRU, I will sponsor it. The policy is here:

https://wiki.ubuntu.com/StableReleaseUpdates

Scott Kitterman (kitterman) wrote :

I got an IRC ack from motu-sru last night, but it doesn't appear to have made it in the bug.

Luke Yelavich (themuso) wrote :

Its a segfault. It needs fixing. ACKing for a MOTU to either upload a fix, or sponsor an upload to fix the bug.

Changed in firestarter:
status: New → Confirmed
Matti Lindell (mlind) wrote :

I'll prepare a debdiff today. What's the preferred version number for gutsy-proposed pocket?

Changed in firestarter:
assignee: nobody → mlind
status: Confirmed → In Progress
Luca Falavigna (dktrkranz) wrote :

For gutsy-proposed, I'd suggest 1.0.3-6ubuntu1.1.

Scott Kitterman (kitterman) wrote :

I agree.

Matti Lindell (mlind) wrote :

Here's a debdiff for gutsy-proposed.

description: updated
Changed in firestarter:
assignee: mlind → nobody
status: In Progress → Confirmed
Luca Falavigna (dktrkranz) wrote :

Are remaining supported versions affected too? If so, it could be worth fix them as well.

Scott Kitterman (kitterman) wrote :

From my reading of the bug, I think this is a Gutsy only problem.

Matti Lindell (mlind) wrote :

Feisty or earlier is not affected by this as the g_slice memory allocator (that's exposing the bug) was introduced in glib 2.14 (http://live.gnome.org/TwoPointThirteen/ReleaseNotes). Feisty's glib is 2.12.

Bajusz Tamás (gbtami) wrote :

I'm using an uptodate ubuntu-gutsy. Installed firestarter from here:
http://ppa.launchpad.net/mlind/ubuntu/pool/main/f/firestarter/firestarter_1.0.3-6ubuntu2~gutsy0.1_i386.deb

After playing some time with "Restrictive by default, whitelist traffic" for "Outbound traffic policy" i got this:
***MEMORY-ERROR***: firestarter[17797]: GSlice: assertion failed: sinfo->n_allocated > 0

I think there are similar bugs hiding in the code somewhere.

Matti Lindell (mlind) wrote :

Bajusz, it sounds like there's still a leak at least in preferences view.

Changed in firestarter:
status: Unknown → New
Luca Falavigna (dktrkranz) wrote :

Playing with grep, here's the results:

$ grep * -rie "gtk_tree_iter_free"
src/policyview.c: gtk_tree_iter_free (iter);
src/policyview.c: gtk_tree_iter_free (iter);
src/preferences.c: gtk_tree_iter_free (top_section);
$

src/policyview.c and src/preferences.c stillneeds to be fixed.

Luca Falavigna (dktrkranz) wrote :

Any news on this? If not, I'll try to patch these files as well in Hardy in the next few days.

Matti Lindell (mlind) wrote :

Reopening for Hardy.

Changed in firestarter:
status: Fix Released → Triaged
Matti Lindell (mlind) wrote :

I can reproduce the crash in policyview. Leftover gtk_tree_iter_free calls in preferences.c are freeing resources allocated by gtk_tree_iter_copy and this is right thing to do. policyview.c has one case in which GtkTreeIter is being allocated by g_new and free'd using gtk_tree_iter_free which is wrong. The other I'm not sure about, pointer is fetched using g_object_steal_data and free'd using gtk_tree_iter_free.

I'll fix the obvious case and see if it fixes the crasher people are still having. Maybe session with Valgrind will expose if the other case is valid too.

cb474 (cb474) wrote :

I'm experiencing this problem on a Debian Testing/Unstable system, with Firestarter 1.0.3-6.

RobNeild (b-bigbob) wrote :

Here is a tentative debdiff for hardy. It will need to be looked over and tested.

On hardy, you could do something like.....

sudo apt-get build-dep firestarter ; sudo apt-get install fakeroot ; apt-get source firestarter
patch -p0 < debdiff.txt
cd firestarter-1.0.3
dpkg-buildpackage -rfakeroot
cd ..
sudo dpkg -i firestarter_1.0.3-6ubuntu1_i386.deb

Matti Lindell (mlind) wrote :

Luca, any chances for getting Rob's patch in Hardy?

Luca Falavigna (dktrkranz) wrote :

I've subscribed motu-release to receive ACK to upload new revision in Hardy.
Rob, mind adding your changes to existing debian/patches/18_fix_memleak.dpatch? This way we can give Debian and upstream a single patch instead of two.

Changed in firestarter:
status: Triaged → New
RobNeild (b-bigbob) wrote :

Give this a try. Combined patch 18 & 19
A few people should try this out before it is submitted.

Matti Lindell (mlind) wrote :

Thanks Rob, I'll try out the patch tomorrow and report if I can still trigger the crash in policyview. You might want to reconsider the patch comment though ;)

Luca Falavigna (dktrkranz) wrote :

I'll try myself too to see if crashes still happen since I was able to trigger some. If we can have proper testing, I'll manage upload in a couple of days. Matti, once this is really fixed in Hardy, we can proceed with the SRU for Gutsy.

Changed in firestarter:
assignee: kitterman → dktrkranz
status: New → In Progress
Matti Lindell (mlind) wrote :

The new patch submitted by Rob fixes the policyview crasher for me. I was able to trigger it with current version (1.0.3-6ubuntu2), but not after applying Rob's patch. Thanks again!

No regressions spotted either.

Luca Falavigna (dktrkranz) wrote :

I tested new candidate and seems good, uploaded.

Changed in firestarter:
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package firestarter - 1.0.3-6ubuntu3

---------------
firestarter (1.0.3-6ubuntu3) hardy; urgency=low

  * debian/patches/18_fix_memleak.dpatch:
    - Even more memory leaks added into patch 18 (LP: #120445).

 -- Rob Neild <email address hidden> Wed, 09 Apr 2008 23:50:18 +0100

Changed in firestarter:
status: Fix Committed → Fix Released
Matti Lindell (mlind) wrote :

Rob, could you post the latest patch also as SRU for gutsy-proposed as it's your work. The procedure is described in https://wiki.ubuntu.com/StableReleaseUpdates. Steps described in the "Procedure" section before step 4 are done, unless this needs a re-ack from motu-sru. Example of the proposed patch is attached in https://bugs.launchpad.net/ubuntu/+source/firestarter/+bug/120445/comments/67.

Does this need a re-ack from motu-sru ?

Luca Falavigna (dktrkranz) wrote :

If it's needed, here it is: ACK to fix segfaults in Gutsy.

cement_head (andor-udel) wrote :

what will the fixed package in Gutsy be "1.0.3-6ubuntu4"?

- Thanks

Changed in firestarter:
status: New → Fix Released
Sergio Zanchetta (primes2h) wrote :

The 18 month support period for Gutsy Gibbon 7.10 has reached its end of life -
http://www.ubuntu.com/news/ubuntu-7.10-eol . As a result, we are closing the
Gutsy task.

Changed in firestarter (Ubuntu Gutsy):
status: Confirmed → Won't Fix
Changed in firestarter:
importance: Unknown → Critical
status: New → Expired
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.